<?php

 $g_comments = new Comments();

 class Comments
 {
  function Comments()
  {
  }

  function recentCommentedNotes($start=0,$count=0)
  {
   // Should be possible to do this with just one sql query.
   // Stopgap solution below.
   global $db_database,$g_notes,$g_users,$g_comments;

   $sql = "select NoteComment.NoteID, max(Comment.CreatedDate) AS LastUpdate FROM NoteComment, Comment WHERE NoteComment.CommentID = Comment.CommentID GROUP BY NoteComment.NoteID ORDER BY LastUpdate DESC ";

   if($count!=0)
   {
    $sql.="LIMIT $start,$count";
   }

   $result = $db_database->query($sql);
   while(is_array($array = $db_database->fetch_array($result)))
   {
    $noteID = $array["NoteID"];
    $lastUpdate = $array["LastUpdate"];
    $note = $g_notes->getNoteByID($noteID);
    $commentCount = $note->commentCount;
    $title = $note->title;

    $sql2 = "SELECT Comment.CommentID, Comment.CreatedDate, Comment.CreatedByUserID AS UserID, User.Username FROM NoteComment, Comment, User WHERE NoteComment.CommentID = Comment.CommentID AND NoteComment.NoteID = '$noteID' AND Comment.CreatedByUserID = User.UserID ORDER BY CreatedDate DESC LIMIT 1;";

    $result2 = $db_database->query($sql2);
    $array2 = $db_database->fetch_array($result2);

    $commentID = $array2["CommentID"];
    $createdDate = $array2["CreatedDate"];
    $userID = $array2["UserID"];
    $username = $array2["Username"];

    $post = array();
    $post["NoteID"] = $noteID;
    $post["Title"] = $title;
    $post["CommentCount"] = $commentCount;
    $post["CommentID"] = $commentID;
    $post["CreatedDate"] = $createdDate;
    $post["CreatedByUserID"] = $userID;
    $post["Username"] = $username;

    $list[$noteID] = $post;
   }
   return $list;
  }

  function deleteComment($commentid)
  {
   global $db_database;

   if(!is_numeric($commentid))
   {
    return;
   }

   $db_database->startTransaction();

   $sql1 = "DELETE From Comment WHERE CommentID = '$commentid'";
   $sql2 = "DELETE From NoteComment WHERE CommentID = '$commentid'";
   $sql3 = "DELETE From ThreadComment WHERE CommentID = '$commentid'";

   $db_database->query($sql1);
   $db_database->query($sql2);
   $db_database->query($sql3);

   $db_database->endTransaction();
  }

  function lockCommentByID($commentid)
  {
   $comment = $this->getCommentByID($commentid);
   if(is_object($comment))
   {
    $comment->locked = 1;
    $comment->store();
   }
  }

  function unlockCommentByID($commentid)
  {
   $comment = $this->getCommentByID($commentid);
   if(is_object($comment))
   {
    $comment->locked = 0;
    $comment->store();
   }
  }

  function getCommentByID($commentid)
  {
   $comment = new Comment();
   $comment->commentID = $commentid;
   $res=$comment->load();

   if($res===false)
   {
    return false;
   }

   return $comment;
  }

  function getNoteCommentCountByUserID($userid)
  {
   global $db_database;

   $sql = "SELECT COUNT(Distinct Comment.CommentID) AS count FROM Comment,NoteComment WHERE Comment.CommentID = NoteComment.CommentID AND Comment.CreatedByUserID = '$userid'";

   $result = $db_database->query($sql);

   $array = $db_database->fetch_array($result);
   $count = $array["count"];

   return $count;
  }

  function getThreadCommentCountByUserID($userid)
  {
   global $db_database,$g_user;

   $accesslevelid = $g_user->accessLevelID;

   if(is_object($g_user) && $g_user->access("MODERATOR"))
   {
    $hidden = "";
   }
   else
   {
    $hidden = " AND Thread.IsHidden = 0";
   }

   $sql = "
SELECT COUNT(
 Comment.CommentID) AS count 
FROM Comment,ThreadComment, Thread,Forum
WHERE
 Comment.CommentID = ThreadComment.CommentID
 AND Thread.ThreadID = ThreadComment.ThreadID
 AND Forum.ForumID = Thread.ForumID
 AND Comment.CreatedByUserID = '$userid'
 AND Forum.ReadAccessLevelID <= '$accesslevelid'
 $hidden
 AND Thread.CommentID <> Comment.CommentID ";

   $result = $db_database->query($sql);

   $array = $db_database->fetch_array($result);
   $count = $array["count"];

   return $count;
  }

  function getCommentCountByNoteID($noteid)
  {
   global $db_database;

   $sql = "SELECT COUNT(NoteCommentID) AS count FROM NoteComment WHERE NoteID='$noteid'";

   $result = $db_database->query($sql);

   $array = $db_database->fetch_array($result);
   $count = $array["count"];

   return $count;
  }

  function getCommentCountByThreadID($threadid,$ignoreid=0)
  {
   global $db_database;

   $sql = "SELECT COUNT(ThreadCommentID) AS count FROM ThreadComment WHERE ThreadID='$threadid' AND CommentID<>$ignoreid";

   $result = $db_database->query($sql);

   $array = $db_database->fetch_array($result);
   $count = $array["count"];

   return $count;
  }

  function getCommentsByNoteID($noteid,$start=0,$count=0)
  {
   global $db_database,$g_comment_sortorder;

   $sql = "SELECT Comment.* FROM NoteComment, Comment WHERE NoteComment.CommentID = Comment.CommentID AND NoteComment.NoteID = '$noteid' ";

   $sql.= "ORDER BY Comment.CreatedDate $g_comment_sortorder ";

   if($count!=0)
   {
    $sql.= "LIMIT $start,$count";
   }

   $result = $db_database->query($sql);
   if($result===false)
   {
    return false;
   }
   return $this->resultIntoArray($result);
  }

  function getCommentsByThreadID($threadid,$ignoreid=0,$start=0,$count=0)
  {
   global $db_database,$g_comment_sortorder;

   $sql = "SELECT Comment.* FROM ThreadComment, Comment WHERE ThreadComment.CommentID = Comment.CommentID AND ThreadComment.ThreadID = '$threadid' AND Comment.CommentID<>'$ignoreid'";

   $sql.= "ORDER BY Comment.CreatedDate $g_comment_sortorder ";

   if($count!=0)
   {
    $sql.= "LIMIT $start,$count";
   }

   $result = $db_database->query($sql);
   if($result===false)
   {
    return false;
   }
   return $this->resultIntoArray($result);
  }

  function getRecentComments($max=0)
  {
   global $db_database;

   $sql = "SELECT * FROM Comment ORDER BY CreatedDate DESC";

   if($max!=0)
   {
    $sql.=" LIMIT 0,$max";
   }

   $result = $db_database->query($sql);
   if($result===false)
   {
    return false;
   }
   return $this->resultIntoArray($result);
  }

  function getCommentsByUserID($userid,$start=0,$end=0)
  {
   global $db_database;

   $sql = "SELECT * FROM Comment WHERE CreatedByUserID=$userid ORDER BY CreatedDate";

   if($end!=0)
   {
    $sql.= " LIMIT $start,$end";
   }

   $result = $db_database->query($sql);
   if($result===false)
   {
    return false;
   }
   return $this->resultIntoArray($result);
  }

  function resultIntoArray($result)
  {
   global $db_database;

   $list = array();

   while(is_array($array = $db_database->fetch_array($result)))
   {

    $comment = new Comment();
    $comment->insertArray($array);
    $list[$comment->commentID] = $comment;
   }

   return $list;
  }

  function getNoteCommentsByUserID($userid,$orderby="",$order="",$start=0,$amount=0)
  {
   global $db_database;

   $list = array();

   if(!is_numeric($userid))
   {
    return $list;
   }

   $sql = "SELECT Comment.CommentID,Comment.Title,Comment.CreatedDate,NoteComment.NoteID FROM Comment,NoteComment WHERE Comment.CommentID = NoteComment.CommentID AND Comment.CreatedByUserID = '$userid' ";

   if($orderby!="")
   {
    $sql.= "ORDER BY $orderby $order ";
   }

   if($amount!=0)
   {
    $sql.= "LIMIT $start,$amount";
   }

   $result = $db_database->query($sql);

   if($result===false)
   {
    return $list;
   }

   while(is_array($array = $db_database->fetch_array($result)))
   {
    $commentid = $array["CommentID"];
    $title = $array["Title"];
    $createdDate = $array["CreatedDate"];
    $noteID = $array["NoteID"];

    $line = array();
    $line["CommentID"] = $commentid;
    $line["Title"] = $title;
    $line["CreatedDate"] = $createdDate;
    $line["NoteID"] = $noteID;
    $list[$commentid] = $line;
   }

   return $list;
  }

  function getThreadCommentsByUserID($userid,$orderby="",$order="",$start=0,$count=0)
  {
   global $db_database,$g_user;

   $list = array();

   $accesslevelid = $g_user->accessLevelID;

   if(is_object($g_user) && $g_user->access("MODERATOR"))
   {
    $hidden = "";
   }
   else
   {
    $hidden = " AND Thread.IsHidden = 0";
   }

   $sql = "
SELECT
 Comment.*, Thread.ThreadID AS ThreadID
FROM Comment,ThreadComment, Thread,Forum
WHERE
 Comment.CommentID = ThreadComment.CommentID
 AND Thread.ThreadID = ThreadComment.ThreadID 
 AND Forum.ForumID = Thread.ForumID
 AND Comment.CreatedByUserID = '$userid'
 AND Forum.ReadAccessLevelID <= '$accesslevelid'
 $hidden
 AND Thread.CommentID <> Comment.CommentID ";

   if($orderby!="")
   {
    $sql.= "ORDER BY $orderby $order ";
   }

   if($count!=0)
   {
    $sql.= "LIMIT $start,$count";
   }

   $result = $db_database->query($sql);

   if($result===false)
   {
    return $list;
   }

   while(is_array($array = $db_database->fetch_array($result)))
   {
    $commentid = $array["CommentID"];
    $title = $array["Title"];
    $createdDate = $array["CreatedDate"];
    $threadID = $array["ThreadID"];

    $line = array();
    $line["CommentID"] = $commentid;
    $line["Title"] = $title;
    $line["CreatedDate"] = $createdDate;
    $line["ThreadID"] = $threadID;
    $list[$commentid] = $line;
   }



   return $list;
  }

  function storeNoteComment($noteid,$comment)
  {
   global $db_database;
   $db_database->startTransaction();
   $commentid = $comment->store();
   $sql = "INSERT INTO NoteComment ";
   $sql.= "(NoteID, CommentID) ";
   $sql.= "VALUES (";
   $sql.= "'$noteid','$commentid')";
   $db_database->query($sql);
   $db_database->endTransaction();
  }

  function storeThreadComment($threadid,$comment)
  {
   global $db_database;
   $db_database->startTransaction();
   $commentid = $comment->store();
   $sql = "INSERT INTO ThreadComment ";
   $sql.= "(ThreadID, CommentID) ";
   $sql.= "VALUES (";
   $sql.= "'$threadid','$commentid')";
   $db_database->query($sql);
   $db_database->endTransaction();
   return $commentid;
  }
 }

?>
