<?php


 $g_members = new Members();

 class Members
 {

  function Members()
  {
  }

  function getProjectMembers($projectid)
  {
   global $g_users,$g_projects;

   $users = $this->getUsersByProjectID($projectid);

   if(!is_array($users))
   {
    return false;
   }

   $project = $g_projects->getProjectByID($projectid);
   $user = $g_users->getUserByID($project->assignedToUserID);
   if(is_object($user))
   {
    $users[$user->userID] = $user;
   }

   return $users;
  }

  function getUsersByProjectID($projectid)
  {
   global $db_database,$g_users;

   if(!is_numeric($projectid))
   {
    return false;
   }

   $sql = "SELECT User.* FROM Member AS Member, User AS User WHERE User.UserID = Member.UserID AND Member.ProjectID=$projectid";

   $result = $db_database->query($sql);
   if($result===false)
   {
    return false;
   }

   return $g_users->resultIntoArray($result);
  }

  function getProjectsByUserID($userid)
  {
   global $db_database,$g_projects;

   if(!is_numeric($userid))
   {
    return false;
   }

   $sql = "SELECT Project.*, ";
   $sql.= "SUM(Donation.Amount) AS Amount, ";
   $sql.= "SUM(Donation.OriginalAmount) AS OriginalAmount ";
   $sql.= "FROM (Member INNER JOIN Project ";
   $sql.= "ON Member.ProjectID=Project.ProjectID) ";
   $sql.= "LEFT JOIN Donation ON Project.ProjectID = Donation.ProjectID ";
   $sql.= "WHERE Member.UserID = '$userid' ";
   $sql.= "GROUP BY Project.ProjectID, Member.UserID ";
   $sql.= "ORDER BY Project.CreatedDate DESC";

   // $sql = "SELECT Project.* FROM Member AS Member, Project AS Project WHERE Project.ProjectID = Member.ProjectID AND Member.UserID=$userid";

   $result = $db_database->query($sql);
   if($result===false)
   {
    return false;
   }

   return $g_projects->resultIntoArray($result);
  }

  function isMember($userid,$projectid)
  {
   global $db_database,$g_projects;

   if(!is_numeric($userid) || !is_numeric($projectid))
   {
    return false;
   }

   $project = $g_projects->getProjectByID($projectid);

   if($project===false)
   {
    return false;
   }

   if($userid!=0 && $project->assignedToUserID == $userid)
   {
    return true;
   }

   $sql = "SELECT count(*) AS count FROM Member WHERE UserID=$userid && ProjectID=$projectid";

   $result = $db_database->query($sql);
   if($result===false)
   {
    return false;
   }

   $array = $db_database->fetch_array($result);
   $count = $array["count"];
   if(is_numeric($count) && $count>0)
   {
    return true;
   }

   return false;
  }

  function addUserToProject($userid,$projectid)
  {
   global $db_database;

   if(!is_numeric($userid) || !is_numeric($projectid))
   {
    return false;
   }

   if(!$this->isMember($userid,$projectid))
   {
    $sql = "INSERT INTO Member (UserID,ProjectID) ";
    $sql.= "VALUES (";
    $sql.= "'$userid','$projectid')";
   }

   $result = $db_database->query($sql);

   if($result===false)
   {
    return false;
   }
   return true;
  }

  function removeUserFromProject($userid,$projectid)
  {
   global $db_database;

   if(!is_numeric($userid) || !is_numeric($projectid))
   {
    return;
   }

   $sql = "DELETE FROM Member WHERE UserID=$userid AND ProjectID=$projectid";
   $result = $db_database->query($sql);
  }
 }

?>
