<?php

 include_once("settings/accesslabels.php");

 class User
 {
  var $userID;
  var $accessLevelID;
  var $username;
  var $password;
  var $contactEmail;
  var $fullName;
  var $homepageURL;
  var $description;
  var $userIconURL;
  var $createdDate;
  var $validationString;

  function access($accesslabel)
  {
   global $g_accesslabels;

   $accesslevels = $g_accesslabels[$accesslabel];

   for($i=0;$i<count($accesslevels);$i++)
   {
    if($accesslevels[$i]==$this->accessLevelID)
    {
     return true;
    }
   }
   return false;
  }

  function isAvatarLocked()
  {
   if(strlen($this->userIconURL)>0 && $this->userIconURL[0]==";")
   {
    return true;
   }

   return false;
  }

  function lockAvatar()
  {
   if(!$this->isAvatarLocked())
   {
    $this->userIconURL = ";".$this->userIconURL;
    $this->store();
   }
  }

  function unlockAvatar()
  {
   if($this->isAvatarLocked())
   {
    $this->userIconURL = substr($this->userIconURL,1);
    $this->store();
   }
  }
 
  function getAvatarURL()
  {
   if($this->isAvatarLocked())
   {
    return substr($this->userIconURL,1);
   }
   return $this->userIconURL;
  }

  function User()
  {
   $this->userID = "";
  }

  function isDuplicateUsername($username="")
  {
   global $db_database;

   
   if($username=="")
   {
    $sql = "SELECT count(*) AS count FROM User WHERE Username='".$this->username."'";
   }
   else
   {
    $sql = "SELECT count(*) AS count FROM User WHERE Username='$username' AND UserID<>".$this->userID;
   }

   $result = $db_database->query($sql);

   $array = $db_database->fetch_array($result);
   $count = $array["count"];

   if(is_numeric($count) && $count>0)
   {
    return true;
   }

   return false;
  }

  function count()
  {
   global $db_database;

   $sql = "SELECT count(*) AS count FROM User";

   $result = $db_database->query($sql);
   $array = $db_database->fetch_array($result);
   $count = $array["count"];

   return $count;
  }

  function insertArray($array)
  {
   $this->userID = $array["UserID"];
   $this->username = $array["Username"];
   $this->accessLevelID = $array["AccessLevelID"];
   $this->password = $array["Password"];
   $this->contactEmail = $array["ContactEmail"];
   $this->fullName = $array["FullName"];
   $this->homepageURL = $array["HomepageURL"];
   $this->description = $array["Description"];
   $this->userIconURL = $array["UserIconURL"];
   $this->createdDate = $array["CreatedDate"];
   $this->validationString = $array["ValidationString"];
  }

  function load()
  {
   global $db_database;

   if(is_numeric($this->userID))
   {
    $sql = "SELECT * FROM User WHERE UserID = $this->userID";
   }
   else if($this->username!="")
   {
    $sql = "SELECT * FROM User WHERE Username = '$this->username'";
   }
   else
   {
    return false;
   }

   $result = $db_database->query($sql);
   if($result===false)
   {
    return false;
   }

   $array = $db_database->fetch_array($result);
   if($array===false)
   {
    return false;
   }

   $this->insertArray($array);
  }

  function store()
  {
   global $db_database;

/*
   echo "<BR />Storing:</BR />";
   print_r($this);
   echo "<BR />";
*/

   if($this->username=="")
   {
    return false;
   }

   if($this->password=="")
   {
    return false;
   }

   if(!is_numeric($this->accessLevelID))
   {
    $this->accessLevelID = 0;
   }

   if(!is_numeric($this->createdDate))
   {
    $this->createdDate = time();
   }

   if(!is_numeric($this->userID))
   {
    $this->userID = 0;
   }

   if($this->userID==0)
   {
    $sql = "INSERT INTO User ";
    $sql.= "(AccessLevelID, Username,Password,";
    $sql.= "ContactEmail,FullName,HomepageURL,Description,";
    $sql.= "UserIconURL,CreatedDate,ValidationString) ";
    $sql.= "VALUES (";
    $sql.= $this->accessLevelID.",";
    $sql.= "'".$db_database->escape_string($this->username)."',";
    $sql.= "'".$db_database->escape_string($this->password)."',";
    $sql.= "'".$db_database->escape_string($this->contactEmail)."',";
    $sql.= "'".$db_database->escape_string($this->fullName)."',";
    $sql.= "'".$db_database->escape_string($this->homepageURL)."',";
    $sql.= "'".$db_database->escape_string($this->description)."',";
    $sql.= "'".$db_database->escape_string($this->userIconURL)."',";
    $sql.= $this->createdDate.",";
    $sql.= "'".$db_database->escape_string($this->validationString)."')";
   }
   else
   {
    $sql = "UPDATE User SET ";
    $sql.= "AccessLevelID = ".$this->accessLevelID.",";
    $sql.= "Username = '".$db_database->escape_string($this->username)."',";
    $sql.= "Password = '".$db_database->escape_string($this->password)."',";
    $sql.= "ContactEmail = '".$db_database->escape_string($this->contactEmail)."',";
    $sql.= "FullName = '".$db_database->escape_string($this->fullName)."',";
    $sql.= "HomepageURL = '".$db_database->escape_string($this->homepageURL)."',";
    $sql.= "Description = '".$db_database->escape_string($this->description)."',";
    $sql.= "UserIconURL = '".$db_database->escape_string($this->userIconURL)."',";
    $sql.= "CreatedDate = ".$this->createdDate.",";
    $sql.= "ValidationString = '".$db_database->escape_string($this->validationString)."' ";
    $sql.= "WHERE UserID = ".$this->userID;
   }

   //echo $sql;

   $result = $db_database->query($sql);

   return $result;
  }

  function toString($html=true)
  {
   if($html)
   {
    $eol = "<BR />";
   }
   else
   {
    $eol = "\n";
   }

   $str = "";

   $str.= "UserID = ".$this->userID.$eol;
   $str.= "AccessLevelID = ".$this->accessLevelID.$eol;
   $str.= "Username = ".$this->username.$eol;
   $str.= "Password = ".$this->password.$eol;
   $str.= "ContactEmail = ".$this->contactEmail.$eol;
   $str.= "FullName = ".$this->fullName.$eol;
   $str.= "HomepageURL = ".$this->homepageURL.$eol;
   $str.= "Description = ".$this->description.$eol;
   $str.= "UserIconURL = ".$this->userIconURL.$eol;
   $str.= "CreatedDate = ".$this->createdDate.$eol;
   $str.= "ValidationString = ".$this->validationString.$eol;

   return $str;
  }

 }


?>
