-- phpMyAdmin SQL Dump
-- version 2.11.3deb1ubuntu1
-- http://www.phpmyadmin.net
--
-- Host: localhost
-- Generation Time: Jul 25, 2008 at 02:30 PM
-- Server version: 5.0.51
-- PHP Version: 5.2.4-2ubuntu5.3

SET SQL_MODE="NO_AUTO_VALUE_ON_ZERO";

--
-- Database: `snack`
--

-- --------------------------------------------------------

--
-- Table structure for table `AccessLevel`
--

DROP TABLE IF EXISTS `AccessLevel`;
CREATE TABLE IF NOT EXISTS `AccessLevel` (
  `AccessLevelID` int(10) NOT NULL default '0',
  `Title` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`AccessLevelID`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `Comment`
--

DROP TABLE IF EXISTS `Comment`;
CREATE TABLE IF NOT EXISTS `Comment` (
  `CommentID` int(10) NOT NULL auto_increment,
  `CreatedByUserID` int(10) NOT NULL default '0',
  `Title` varchar(255) NOT NULL default '',
  `Text` mediumtext NOT NULL,
  `CreatedByIP` varchar(255) NOT NULL default '',
  `CreatedDate` int(10) NOT NULL default '0',
  `Locked` int(1) NOT NULL default '0',
  PRIMARY KEY  (`CommentID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `Folder`
--

DROP TABLE IF EXISTS `Folder`;
CREATE TABLE IF NOT EXISTS `Folder` (
  `FolderID` int(10) NOT NULL auto_increment,
  `UserID` int(10) NOT NULL default '0',
  `Title` varchar(20) NOT NULL default '',
  PRIMARY KEY  (`FolderID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `Forum`
--

DROP TABLE IF EXISTS `Forum`;
CREATE TABLE IF NOT EXISTS `Forum` (
  `ForumID` int(10) NOT NULL auto_increment,
  `ParentForumID` int(10) NOT NULL default '0',
  `ReadAccessLevelID` int(10) NOT NULL,
  `PostAccessLevelID` int(10) NOT NULL,
  `ReplyAccessLevelID` int(10) NOT NULL,
  `Title` varchar(255) NOT NULL,
  `Description` mediumtext NOT NULL,
  `SortOrder` int(4) NOT NULL default '0',
  `IsParent` int(1) NOT NULL default '0',
  PRIMARY KEY  (`ForumID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `Member`
--

DROP TABLE IF EXISTS `Member`;
CREATE TABLE IF NOT EXISTS `Member` (
  `MemberID` int(10) NOT NULL auto_increment,
  `ProjectID` int(10) NOT NULL default '0',
  `UserID` int(10) NOT NULL default '0',
  PRIMARY KEY  (`MemberID`),
  UNIQUE KEY `MemberID` (`ProjectID`,`UserID`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `Message`
--

DROP TABLE IF EXISTS `Message`;
CREATE TABLE IF NOT EXISTS `Message` (
  `MessageID` int(10) NOT NULL auto_increment,
  `UserID` int(10) NOT NULL default '0',
  `ToUserID` int(10) NOT NULL default '0',
  `FromUserID` int(10) NOT NULL default '0',
  `FolderID` int(10) NOT NULL default '0',
  `Title` varchar(255) NOT NULL default '',
  `Text` mediumtext NOT NULL,
  `IsRead` int(1) NOT NULL default '0',
  `IsMarked` int(1) NOT NULL default '0',
  `CreatedDate` int(10) NOT NULL default '0',
  `ReadDate` int(10) NOT NULL default '0',
  PRIMARY KEY  (`MessageID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `Note`
--

DROP TABLE IF EXISTS `Note`;
CREATE TABLE IF NOT EXISTS `Note` (
  `NoteID` int(10) NOT NULL auto_increment,
  `CreatedByUserID` int(10) NOT NULL default '0',
  `CreatedDate` int(10) NOT NULL default '0',
  `Title` varchar(255) NOT NULL default '',
  `Synopsis` mediumtext NOT NULL,
  `Text` mediumtext NOT NULL,
  PRIMARY KEY  (`NoteID`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `NoteComment`
--

DROP TABLE IF EXISTS `NoteComment`;
CREATE TABLE IF NOT EXISTS `NoteComment` (
  `NoteCommentID` int(10) NOT NULL auto_increment,
  `NoteID` int(10) NOT NULL default '0',
  `CommentID` int(10) NOT NULL default '0',
  PRIMARY KEY  (`NoteCommentID`),
  UNIQUE KEY `NoteCommentID` (`NoteID`,`CommentID`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `Page`
--

DROP TABLE IF EXISTS `Page`;
CREATE TABLE IF NOT EXISTS `Page` (
  `PageID` int(10) NOT NULL auto_increment,
  `Name` varchar(255) NOT NULL default '',
  `Content` mediumtext NOT NULL,
  `MenuTitle` varchar(255) NOT NULL default '',
  `Menu` int(1) NOT NULL default '0',
  `TopMenu` int(1) NOT NULL default '0',
  `Access` varchar(255) NOT NULL default '',
  `SortOrder` int(4) NOT NULL default '0',
  PRIMARY KEY  (`PageID`),
  UNIQUE KEY `Name` (`Name`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `Setting`
--

DROP TABLE IF EXISTS `Setting`;
CREATE TABLE IF NOT EXISTS `Setting` (
  `SettingID` int(10) NOT NULL auto_increment,
  `Label` varchar(255) NOT NULL default '',
  `Value` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`SettingID`),
  UNIQUE KEY `Label` (`Label`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `Thread`
--

DROP TABLE IF EXISTS `Thread`;
CREATE TABLE IF NOT EXISTS `Thread` (
  `ThreadID` int(10) NOT NULL auto_increment,
  `ForumID` int(10) NOT NULL,
  `CommentID` int(10) NOT NULL default '0',
  `LastCommentID` int(10) NOT NULL default '0',
  `IsLocked` int(11) NOT NULL default '0',
  `IsSticky` int(11) NOT NULL default '0',
  `IsHidden` int(11) NOT NULL default '0',
  PRIMARY KEY  (`ThreadID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `ThreadComment`
--

DROP TABLE IF EXISTS `ThreadComment`;
CREATE TABLE IF NOT EXISTS `ThreadComment` (
  `ThreadCommentID` int(10) NOT NULL auto_increment,
  `ThreadID` int(10) NOT NULL,
  `CommentID` int(10) NOT NULL,
  PRIMARY KEY  (`ThreadCommentID`),
  UNIQUE KEY `ThreadCommentID` (`ThreadID`,`CommentID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `User`
--

DROP TABLE IF EXISTS `User`;
CREATE TABLE IF NOT EXISTS `User` (
  `UserID` int(10) NOT NULL auto_increment,
  `AccessLevelID` int(10) NOT NULL default '0',
  `PaymentOptionID` int(10) NOT NULL default '0',
  `Username` varchar(255) NOT NULL default '',
  `Password` varchar(255) NOT NULL default '',
  `PaypalEmail` varchar(255) NOT NULL default '',
  `ContactEmail` varchar(255) NOT NULL default '',
  `FullName` varchar(255) NOT NULL default '',
  `HomepageURL` varchar(255) NOT NULL default '',
  `Description` mediumtext NOT NULL,
  `UserIconURL` varchar(255) NOT NULL default '',
  `CreatedDate` int(10) NOT NULL default '0',
  `PaymentDetails` mediumtext NOT NULL,
  `ValidationString` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`UserID`),
  UNIQUE KEY `Username` (`Username`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;

